require "symbiote/version"

require "symbiote/data_setter"
require "symbiote/situation"
require "symbiote/elements"
require "symbiote/factory"
require "symbiote/pages"

module Symbiote
  module_function

  attr_reader :browser

  def included(caller)
    caller.extend Symbiote::Elements
    caller.extend Symbiote::Pages::Assertion
    caller.__send__ :include, Symbiote::Elements::Accessor
    caller.__send__ :include, Symbiote::Pages
    caller.__send__ :include, Symbiote::DataSetter
  end

  def initialize(browser = nil, &block)
    @browser = Symbiote.browser unless Symbiote.browser.nil?
    @browser = browser if Symbiote.browser.nil?
    instance_eval(&block) if block
  end

  def set_browser(app = :chrome, *args)
    @browser = Watir::Browser.new(app, *args)
    Symbiote.browser = @browser
  end

  def browser=(browser)
    @browser = browser
  end

  def browser
    @browser
  end
end
