module Symbiote
  module Factory
    # Creates a definition context for actions. If an existing context
    # exists, that context will be re-used.
    def on(definition, visit = false, &block)
      unless @context.is_a?(definition)
        @context = definition.new(@browser) if @browser
        @context = definition.new unless @browser
        @context.visit if visit
      end

      yield @context if block
      @context
    end

    # Creates a definition context for actions and establishes the
    # context for execution.
    def on_view(definition, &block)
      on(definition, true, &block)
    end

    alias on_visit on_view
  end
end
