module Symbiote
  include Situation

  module_function

  module Pages
    module Assertion
      include Situation

      def url_is(url)
        url_is_empty if url.nil? || url.empty?
        @url = url
      end

      def asserted_url
        @url
      end

      def title_is(title)
        title_is_empty if title.nil? || title.empty?
        @title = title
      end

      def asserted_title
        @title
      end
    end

    def visit(url = nil)
      no_url_provided if url.nil? && asserted_url.nil?
      browser.goto(url) unless url.nil?
      browser.goto(asserted_url) if url.nil?
      self
    end

    alias perform visit
    alias view visit
    alias navigate_to visit
    alias goto visit

    def asserted_url
      self.class.asserted_url
    end

    def asserted_title
      self.class.asserted_title
    end

    def resize(width, height)
      browser.window.resize_to(width, height)
    end

    def position(x, y)
      browser.window.move_to(x, y)
    end

    def url
      browser.url
    end

    def title
      browser.title
    end
  end
end
